//+------------------------------------------------------------------+
//|                                                    alex11930.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//--- input parameters
extern int       TimeFrame=1;

int K;
//--- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   K=1;
   if (TimeFrame>Period() || TimeFrame==0) {
      TimeFrame=Period();
   } else {
      K=Period()/TimeFrame;
   }

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()  {
   int i, pos, timepos,  counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars;
   if (limit>0) {
      pos=iBars(NULL, TimeFrame)-K;
      limit=iBarShift(NULL, 0, iTime(NULL, TimeFrame, pos));
      for (i=limit;i>0;i--) {
         pos=iBarShift(NULL, TimeFrame, Time[i-1])+1;
         ExtMapBuffer1[i]=iMA(NULL, TimeFrame,K,0,MODE_SMA,PRICE_CLOSE, pos);
      }
      limit=1;
      
   }
   pos=iBarShift(NULL, TimeFrame, Time[0])-1;
   ExtMapBuffer1[1]=iMA(NULL, TimeFrame,K,0,MODE_SMA,PRICE_CLOSE, pos);
   ExtMapBuffer1[0]=iMA(NULL, TimeFrame,K,0,MODE_SMA,PRICE_CLOSE, 0);

   return(0);
  }
//+------------------------------------------------------------------+